<!-- Displays all teams for one competition. -->

{% extends 'main/base.html' %}
{% load static %}
{% load scouting_extras %}

{% block stylesheets %}
<link rel="stylesheet" href="{% static 'scouting/css/indexComp.css' %}">
{% endblock %}

{% block js %}
<script type="text/javascript" src="{% static 'scouting/js/searchComp.js' %}"></script>
<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/chart.js@2.8.0/dist/Chart.min.js"></script>
{% endblock %}

{% block nav_home %} class="button" {% endblock %}
{% block nav_scouting %} class="button-selected" {% endblock %}
{% block nav_contact %} class="button" {% endblock %}
{% block nav_sign-in %} class="button" {% endblock %}

{% block content %}
  
  <div class="page-tlt">
    <h1>
      {% if comp %} {{ comp.Name }}
      {% else %} [404: Name not found]
      {% endif %}
    </h1>
    <div class="right-triangle-decoration page-tlt-triangle wss"></div>
  </div>
  
  <div class="nav-two-row">
    <a href="{% url 'scouting:index' %}" class = "match-button"> <i class="fas fa-caret-left"></i> Back to Index</a>
    <a href="{% url 'scouting:newmatchform' %}" class="add-match" > <i class="fas fa-plus"></i> Add Match</a>
    <a href="{% url 'scouting:indexMatch' comp.id %}" class = "match-button"> View all matches </a> 
  </div>

  <div class="body-content">
    {% if teams and comp %}
      <h2 class = "team-header" >Teams and Scores </h2>

      <div class = "charts">
          <canvas id="canvas" height="100px"></canvas>
      </div>
      
      <div class="search-bar">
          <h1><i class="fas fa-search"></i></h1>
          <input id="search-input" type="text" placeholder='Search Teams..' onkeyup="myFunction()">
      </div>
      
      <div class = "average-table">
          <table id="teamTable">
            <thead> <tr>
                <th onclick="sortTable(0)" class = "highlightedCell"> <div class = "inline"> Team  <i class="fas fa-sort"> </i>  </div> </th> 
                <th onclick="sortTable(1)"> <div class = "inline"> Composite Score  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(2)"> <div class = "inline"> Start  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(3)"> <div class = "inline"> S.R. Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(4)"> <div class = "inline"> S.R. Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(5)"> <div class = "inline"> S.CS. Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(6)"> <div class = "inline"> S.CS. Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(7)"> <div class = "inline"> R.1 Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(8)"> <div class = "inline"> R.1 Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(9)"> <div class = "inline"> R.2 Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(10)"> <div class = "inline"> R.2 Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(11)"> <div class = "inline"> R.3 Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(12)"> <div class = "inline"> R.3 Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(13)"> <div class = "inline"> CS. Hatches  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(14)"> <div class = "inline"> CS. Cargo  <i class="fas fa-sort"> </i> </div> </th>
                <th onclick="sortTable(15)"> <div class = "inline"> Climbing  <i class="fas fa-sort"> </i> </div> </th>
            </tr> </thead>     
            
              {% for t in teams %}
                  <tr>
                    <td class = "fixed"> <a href="{% url 'scouting:indexTeamComp' comp.id t.id %}" class = "view">Team {{ t.TeamNum }} </a> </td>
                  
                    {% for i in teamScores|index:forloop.counter0 %}
                      <td>{{ teamScores|index:forloop.parentloop.counter0|index:forloop.counter0 }}</td>
                    {% endfor %}
                    
                  </tr>
              {% endfor %}
          
          </table>
      </div>
        
    {% else %}
        <p>No data is available, or there has been an error. Contact programming if this message appears after data has been entered.</p>
    {% endif %}
  </div>
    
<script>
    function sortTable(n) {
      var table, rows, switching, i, j, x, y, cell, shouldSwitch, dir, switchcount = 0;
      table = document.getElementById("teamTable");
      switching = true;
      // Set the sorting direction to ascending:
      dir = "asc"; 
      rows = table.rows;
      // Change the appearance of the selected header
      for (j = 0; j < rows[0].cells.length; j++) {
        cell = rows[0].cells[j];
        
        if(j == n) {
          //set the cell class to change appearance
          cell.classList.add("highlightedCell");
        } else {
          //remove the cell class
          cell.classList.remove("highlightedCell");
        }
      }
      
      /* Make a loop that will continue until
      no switching has been done: */
      while (switching) {
        // Start by saying: no switching is done:
        switching = false;
        rows = table.rows;
        /* Loop through all table rows (except the
        first, which contains table headers): */
        for (i = 1; i < (rows.length - 1); i++) {
          // Start by saying there should be no switching:
          shouldSwitch = false;
          /* Get the two elements you want to compare,
          one from current row and one from the next: */
          x = rows[i].getElementsByTagName("TD")[n];
          y = rows[i + 1].getElementsByTagName("TD")[n];
          /* Check if the two rows should switch place,
          based on the direction, asc or desc: */
          if (dir == "asc" && n != 0) {
            if (parseFloat(x.textContent.toLowerCase()) < parseFloat(y.textContent.toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "desc" && n != 0) {
            if (parseFloat(x.textContent.toLowerCase()) > parseFloat(y.textContent.toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "asc" && n == 0) {
            if (parseFloat(x.textContent.substring(5).toLowerCase()) < parseFloat(y.textContent.substring(5).toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "desc" && n == 0) {
              console.log(parseFloat(x.textContent.substring(5)));
            if (parseFloat(x.textContent.substring(5).toLowerCase()) > parseFloat(y.textContent.substring(5).toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          }
        }
        if (shouldSwitch) {
          /* If a switch has been marked, make the switch
          and mark that a switch has been done: */
          rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
          switching = true;
          // Each time a switch is done, increase this count by 1:
          switchcount ++; 
        } else {
          /* If no switching has been done AND the direction is "asc",
          set the direction to "desc" and run the while loop again. */
          if (switchcount == 0 && dir == "asc") {
            dir = "desc";
            switching = true;
          }
        }
      }
    }
</script>
<script type="text/javascript">
    var ctx = document.getElementById('canvas').getContext('2d');
    Chart.defaults.global.defaultFontColor = '#FeFFF7';
    var myChart = new Chart(ctx, {
        type: 'bar',
        data: {
            labels: {{ graph.0 }},
            datasets: [{
                label: '# of Votes',
                data: {{ graph.1 }},
                backgroundColor: [
                    'rgba(255, 99, 132, 0.2)',
                    'rgba(54, 162, 235, 0.2)',
                    'rgba(255, 206, 86, 0.2)',
                    'rgba(75, 192, 192, 0.2)',
                    'rgba(153, 102, 255, 0.2)',
                    'rgba(255, 159, 64, 0.2)'
                ],
                borderColor: [
                    'rgba(255, 99, 132, 1)',
                    'rgba(54, 162, 235, 1)',
                    'rgba(255, 206, 86, 1)',
                    'rgba(75, 192, 192, 1)',
                    'rgba(153, 102, 255, 1)',
                    'rgba(255, 159, 64, 1)'
                ],
                borderWidth: 1
            }]
        },
        options: {
            scales: {
                yAxes: [{
                    ticks: {
                        beginAtZero: true
                    }
                }]
            },
        }
    });
</script>

{% endblock %}